#include <iostream>
#include <memory>
using namespace std;
 
weak_ptr<int> gwp;
 
void observe_gwp() {
	cout << "use_count(): " << gwp.use_count() << ", id: ";
	if (auto sp_local = gwp.lock()) cout << *sp_local << endl;
	else cout << "???" << endl;
}

int main() {
	observe_gwp();
	{
		auto sp = make_shared<int>(42); // : 0
		gwp = sp;
		observe_gwp(); // : 1
		observe_gwp(); // : 1
	}
	observe_gwp(); // : 0
}

