#include <iostream>
#include <memory>
using namespace std;

class B;

class A {
public:
//	weak_ptr<B> pb;
	shared_ptr<B> pb;
	void do_something() {
//		if (pb.lock()) {
			cout << "pb use count: " << pb.use_count() << endl;
//		}
	}

	~A() {
		cout << "kill A\n";
	}
};

class B {
public:
//	weak_ptr<A> pa;
	shared_ptr<A> pa;
	~B() {
		cout << "kill B\n";
	}
};

int main() {
	shared_ptr<A> sa(new A());
	shared_ptr<B> sb(new B());
	if(sa && sb) {
		sa->pb = sb;
		sb->pa = sa;
	}
	sa->do_something();
	cout << "sa use count: " << sa.use_count() << endl;
	cout << "sb use count: " << sb.use_count() << endl;
	return 0;
}

